unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    Panel3: TPanel;
    Panel4: TPanel;
    DriveComboBox1: TDriveComboBox;
    Panel5: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    procedure MakeTree;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TreeCount, FilesCount, DirsCount : integer;
  TreeSize, FilesSize, DirsSize : comp;
implementation

uses Unit2, Unit3;

{$R *.DFM}

procedure TForm1.MakeTree;
var  Sr : TSearchRec;
     Err : integer;
     TrSize, FilePath : string;
Begin
 Err:=FindFirst('*.*',$37,Sr) ;
 While (Err = 0) do
  begin
   if Sr.Name[1]<>'.' then
   begin
     FilePath:=ExpandFileName(Sr.Name);
     TreeSize:=TreeSize+Sr.Size;
     TrSize:=FloatToStr(TreeSize);
     Form1.Caption:=DirectoryListBox1.Directory+'  '+IntToStr(TreeCount)
                   +'  files and folders    Size: '+TrSize;
     if (Sr.Attr and faDirectory)=0 then
        begin
          FilesSize:=FilesSize+Sr.Size;
          inc(FilesCount);
        end;
     inc(TreeCount);
   end;

   { Begin Recursion }
   If ((Sr.Attr and faDirectory)<>0)AND(Sr.Name[1] <> '.') then
   begin
     DirsSize:=DirsSize+Sr.Size;
     inc(DirsCount);
     ChDir(Sr.Name) ;
     MakeTree ;
     ChDir('..') ;
   end ;
   { End Recursion }
   Err:=FindNext(Sr) ;
  end ;
End;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 TreeCount:=1;
 FilesCount:=0;
 DirsCount:=0;
 TreeSize:=0;
 FilesSize:=0;
 DirsSize:=0;
 ChDir(DirectoryListBox1.Directory);
 MakeTree;
 Form2.ShowModal;
end;


procedure TForm1.FormResize(Sender: TObject);
begin
    BitBtn1.Left:=round((Form1.Width-BitBtn1.Width)/2)-5;
    DriveComboBox1.Left:=round((Form1.Width-DriveComboBox1.Width)/2-5);
end;

end.
